#include "GLText.h"
#include "GLViewer.h"



using namespace GLW;

// ************************************************************  
// ****		N A M E S P A C E		G L W			START  ****
namespace GLW
{
// ************************************************************  

 //Object implementation
FXIMPLEMENT(GLText,GLObject,NULL,0)


GLText::GLText()
{
	font=NULL;
	list=0;
}
GLText::GLText(FXApp* app)
{
	font=new FXFont(app,"helvetica",8);
	font->create();
	list=glGenLists(font->getMaxChar()+1);
	glUseFXFont(font,font->getMinChar(),
		font->getMaxChar()-font->getMinChar()+1,list+font->getMinChar());
	

}
  /// Called by the viewer to get bounds for this object
void GLText::bounds(FXRange& box)
{
	float eqsz=1.0;
	float neqsz=-1.0;
	box[0][0]=neqsz;  box[0][1]=eqsz;
	box[1][0]=neqsz;  box[1][1]=eqsz;
	box[2][0]=neqsz;  box[2][1]=eqsz;


}
// SOME IDEAS IN THE TWO FOLLOWING METHODS ARE DUE TO NEHE PRODUCTIONS
// VISIT http://nehe.gamedev.net/
void				GLText::drawText(GLViewer* viewer,const char* fmt, GLdouble* v, ...)
{
	glRasterPos3dv(v);
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(list);									// Sets The Base Character to 32
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits

}
void				GLText::drawText(GLViewer* viewer,const char* fmt, float posx, float posy, float posz, ...)
{
	glRasterPos3f(posx,posy,posz);
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(list);									// Sets The Base Character to 32
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits

}


// ************************************************************  
// ****		N A M E S P A C E		G L W			END    ****
}
// ************************************************************  
